'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Map = exports.HeatMap = exports.InfoWindow = exports.Marker = exports.GoogleApiWrapper = undefined;

var _index = require('C:\\Projects\\Misc\\google-maps-react\\node_modules\\redbox-react\\lib\\index.js');

var _index2 = _interopRequireDefault(_index);

var _index3 = require('C:\\Projects\\Misc\\google-maps-react\\node_modules\\react-transform-catch-errors\\lib\\index.js');

var _index4 = _interopRequireDefault(_index3);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _index5 = require('C:\\Projects\\Misc\\google-maps-react\\node_modules\\react-transform-hmr\\lib\\index.js');

var _index6 = _interopRequireDefault(_index5);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _GoogleApiComponent = require('./GoogleApiComponent');

Object.defineProperty(exports, 'GoogleApiWrapper', {
  enumerable: true,
  get: function get() {
    return _GoogleApiComponent.wrapper;
  }
});

var _Marker = require('./components/Marker');

Object.defineProperty(exports, 'Marker', {
  enumerable: true,
  get: function get() {
    return _Marker.Marker;
  }
});

var _InfoWindow = require('./components/InfoWindow');

Object.defineProperty(exports, 'InfoWindow', {
  enumerable: true,
  get: function get() {
    return _InfoWindow.InfoWindow;
  }
});

var _HeatMap = require('./components/HeatMap');

Object.defineProperty(exports, 'HeatMap', {
  enumerable: true,
  get: function get() {
    return _HeatMap.HeatMap;
  }
});

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _String = require('./lib/String');

var _cancelablePromise = require('./lib/cancelablePromise');

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _components = {
  Map: {
    displayName: 'Map'
  }
};

var _CProjectsMiscGoogleMapsReactNode_modulesReactTransformHmrLibIndexJs2 = (0, _index6.default)({
  filename: 'src/index.js',
  components: _components,
  locals: [module],
  imports: [_react3.default]
});

var _CProjectsMiscGoogleMapsReactNode_modulesReactTransformCatchErrorsLibIndexJs2 = (0, _index4.default)({
  filename: 'src/index.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _index2.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _CProjectsMiscGoogleMapsReactNode_modulesReactTransformHmrLibIndexJs2(_CProjectsMiscGoogleMapsReactNode_modulesReactTransformCatchErrorsLibIndexJs2(Component, id), id);
  };
}

var mapStyles = {
  container: {
    position: 'absolute',
    width: '100%',
    height: '100%'
  },
  map: {
    position: 'absolute',
    left: 0,
    right: 0,
    bottom: 0,
    top: 0
  }
};

var evtNames = ['ready', 'click', 'dragend', 'recenter', 'bounds_changed', 'center_changed', 'dblclick', 'dragstart', 'heading_change', 'idle', 'maptypeid_changed', 'mousemove', 'mouseout', 'mouseover', 'projection_changed', 'resize', 'rightclick', 'tilesloaded', 'tilt_changed', 'zoom_changed'];

var Map = exports.Map = _wrapComponent('Map')(function (_React$Component) {
  _inherits(Map, _React$Component);

  function Map(props) {
    _classCallCheck(this, Map);

    var _this = _possibleConstructorReturn(this, (Map.__proto__ || Object.getPrototypeOf(Map)).call(this, props));

    (0, _invariant2.default)(props.hasOwnProperty('google'), 'You must include a `google` prop.');

    _this.listeners = {};
    _this.state = {
      currentLocation: {
        lat: _this.props.initialCenter.lat,
        lng: _this.props.initialCenter.lng
      }
    };
    return _this;
  }

  _createClass(Map, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      if (this.props.centerAroundCurrentLocation) {
        if (navigator && navigator.geolocation) {
          this.geoPromise = (0, _cancelablePromise.makeCancelable)(new Promise(function (resolve, reject) {
            navigator.geolocation.getCurrentPosition(resolve, reject);
          }));

          this.geoPromise.promise.then(function (pos) {
            var coords = pos.coords;
            _this2.setState({
              currentLocation: {
                lat: coords.latitude,
                lng: coords.longitude
              }
            });
          }).catch(function (e) {
            return e;
          });
        }
      }
      this.loadMap();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      if (prevProps.google !== this.props.google) {
        this.loadMap();
      }
      if (this.props.visible !== prevProps.visible) {
        this.restyleMap();
      }
      if (this.props.zoom !== prevProps.zoom) {
        this.map.setZoom(this.props.zoom);
      }
      if (this.props.center !== prevProps.center) {
        this.setState({
          currentLocation: this.props.center
        });
      }
      if (prevState.currentLocation !== this.state.currentLocation) {
        this.recenterMap();
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var _this3 = this;

      var google = this.props.google;

      if (this.geoPromise) {
        this.geoPromise.cancel();
      }
      Object.keys(this.listeners).forEach(function (e) {
        google.maps.event.removeListener(_this3.listeners[e]);
      });
    }
  }, {
    key: 'loadMap',
    value: function loadMap() {
      var _this4 = this;

      if (this.props && this.props.google) {
        var google = this.props.google;

        var maps = google.maps;

        var mapRef = this.refs.map;
        var node = _reactDom2.default.findDOMNode(mapRef);
        var curr = this.state.currentLocation;
        var center = new maps.LatLng(curr.lat, curr.lng);

        var mapTypeIds = this.props.google.maps.MapTypeId || {};
        var mapTypeFromProps = String(this.props.mapType).toUpperCase();

        var mapConfig = Object.assign({}, {
          mapTypeId: mapTypeIds[mapTypeFromProps],
          center: center,
          zoom: this.props.zoom,
          maxZoom: this.props.maxZoom,
          minZoom: this.props.maxZoom,
          clickableIcons: this.props.clickableIcons,
          disableDefaultUI: this.props.disableDefaultUI,
          zoomControl: this.props.zoomControl,
          mapTypeControl: this.props.mapTypeControl,
          scaleControl: this.props.scaleControl,
          streetViewControl: this.props.streetViewControl,
          panControl: this.props.panControl,
          rotateControl: this.props.rotateControl,
          scrollwheel: this.props.scrollwheel,
          draggable: this.props.draggable,
          keyboardShortcuts: this.props.keyboardShortcuts,
          disableDoubleClickZoom: this.props.disableDoubleClickZoom,
          noClear: this.props.noClear,
          styles: this.props.styles,
          gestureHandling: this.props.gestureHandling
        });

        Object.keys(mapConfig).forEach(function (key) {
          // Allow to configure mapConfig with 'false'
          if (mapConfig[key] == null) {
            delete mapConfig[key];
          }
        });

        this.map = new maps.Map(node, mapConfig);

        evtNames.forEach(function (e) {
          _this4.listeners[e] = _this4.map.addListener(e, _this4.handleEvent(e));
        });
        maps.event.trigger(this.map, 'ready');
        this.forceUpdate();
      }
    }
  }, {
    key: 'handleEvent',
    value: function handleEvent(evtName) {
      var _this5 = this;

      var timeout = void 0;
      var handlerName = 'on' + (0, _String.camelize)(evtName);

      return function (e) {
        if (timeout) {
          clearTimeout(timeout);
          timeout = null;
        }
        timeout = setTimeout(function () {
          if (_this5.props[handlerName]) {
            _this5.props[handlerName](_this5.props, _this5.map, e);
          }
        }, 0);
      };
    }
  }, {
    key: 'recenterMap',
    value: function recenterMap() {
      var map = this.map;

      var google = this.props.google;

      var maps = google.maps;

      if (!google) return;

      if (map) {
        var center = this.state.currentLocation;
        if (!(center instanceof google.maps.LatLng)) {
          center = new google.maps.LatLng(center.lat, center.lng);
        }
        // map.panTo(center)
        map.setCenter(center);
        maps.event.trigger(map, 'recenter');
      }
    }
  }, {
    key: 'restyleMap',
    value: function restyleMap() {
      if (this.map) {
        var google = this.props.google;

        google.maps.event.trigger(this.map, 'resize');
      }
    }
  }, {
    key: 'renderChildren',
    value: function renderChildren() {
      var _this6 = this;

      var children = this.props.children;


      if (!children) return;

      return _react3.default.Children.map(children, function (c) {
        return _react3.default.cloneElement(c, {
          map: _this6.map,
          google: _this6.props.google,
          mapCenter: _this6.state.currentLocation
        });
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var style = Object.assign({}, mapStyles.map, this.props.style, {
        display: this.props.visible ? 'inherit' : 'none'
      });

      var containerStyles = Object.assign({}, mapStyles.container, this.props.containerStyle);

      return _react3.default.createElement(
        'div',
        { style: containerStyles, className: this.props.className },
        _react3.default.createElement(
          'div',
          { style: style, ref: 'map' },
          'Loading map...'
        ),
        this.renderChildren()
      );
    }
  }]);

  return Map;
}(_react3.default.Component));

;

Map.propTypes = {
  google: _react2.PropTypes.object,
  zoom: _react2.PropTypes.number,
  centerAroundCurrentLocation: _react2.PropTypes.bool,
  center: _react2.PropTypes.object,
  initialCenter: _react2.PropTypes.object,
  className: _react2.PropTypes.string,
  style: _react2.PropTypes.object,
  containerStyle: _react2.PropTypes.object,
  visible: _react2.PropTypes.bool,
  mapType: _react2.PropTypes.string,
  maxZoom: _react2.PropTypes.number,
  minZoom: _react2.PropTypes.number,
  clickableIcons: _react2.PropTypes.bool,
  disableDefaultUI: _react2.PropTypes.bool,
  zoomControl: _react2.PropTypes.bool,
  mapTypeControl: _react2.PropTypes.bool,
  scaleControl: _react2.PropTypes.bool,
  streetViewControl: _react2.PropTypes.bool,
  panControl: _react2.PropTypes.bool,
  rotateControl: _react2.PropTypes.bool,
  scrollwheel: _react2.PropTypes.bool,
  draggable: _react2.PropTypes.bool,
  keyboardShortcuts: _react2.PropTypes.bool,
  disableDoubleClickZoom: _react2.PropTypes.bool,
  noClear: _react2.PropTypes.bool,
  styles: _react2.PropTypes.array,
  gestureHandling: _react2.PropTypes.string
};

evtNames.forEach(function (e) {
  return Map.propTypes[(0, _String.camelize)(e)] = _react2.PropTypes.func;
});

Map.defaultProps = {
  zoom: 14,
  initialCenter: {
    lat: 37.774929,
    lng: -122.419416
  },
  center: {},
  centerAroundCurrentLocation: false,
  style: {},
  containerStyle: {},
  visible: true
};

exports.default = Map;